<template>
  <b-modal
    id="importUserModal"
    :title="$t('page.members.importUserTitle')"
    size="lg"
    hide-footer
    @hidden="resetModal"
  >
    <!-- Select Project Drop-Down -->
    <b-row>
      <b-col md="4" align-self="start">
        <b-form-select
          v-model="selectedProject"
          @update:model-value="getProjectRoles"
        >
          <template #first>
            <b-form-select-option :value="null" disabled>{{
              $t("page.members.searchProjectPlaceholder")
            }}</b-form-select-option>
          </template>
          <b-form-select-option
            v-for="additionalProject in additionalProjects"
            :key="additionalProject.id"
            :value="additionalProject.id"
          >
            {{ additionalProject.name }}
          </b-form-select-option>
        </b-form-select>
      </b-col>
    </b-row>
    <br />

    <!-- Members Table -->
    <b-row>
      <b-col>
        <div class="modalTable">
          <MembersTable
            id="projectRolesTable"
            :busy="isBusy"
            :headers="memberHeaders"
            :items="additionalMembers"
            :roles="roles"
            :empty-text="$t('page.members.emptyImportTableText')"
            :empty-filtered-text="$t('page.members.emptyImportTableFilterText')"
            :remove-text="$t('page.members.removeUser')"
            :interactive="true"
            @selectedItem="removeSelectedRow"
          />
        </div>
      </b-col>
    </b-row>
    <br />

    <!-- Import Button -->
    <b-row>
      <b-col>
        <div align="right">
          <!-- Import -->
          <b-button
            name="importUsers"
            :disabled="additionalMembers.length === 0"
            @click="importUser"
            >{{ $t("buttons.import") }}</b-button
          >
        </div>
      </b-col>
    </b-row>

    <br />
  </b-modal>
</template>

<script lang="ts">
import { type TableField, useModal } from "bootstrap-vue-next";
import useProjectStore from "../../../store";

import MembersTable from "../MembersTable.vue";

import type {
  ProjectDto,
  ProjectRoleDto,
  RoleDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  components: {
    MembersTable,
  },
  props: {
    memberHeaders: {
      required: true,
      type: Array as PropType<TableField<ProjectRoleDto>[]>,
    },
    memberRole: {
      default: null,
      type: [Object, null, undefined] as PropType<RoleDto | null | undefined>,
    },
    project: {
      default: null,
      type: [Object, null] as PropType<ProjectDto | null>,
    },
    projectRoles: {
      default: null,
      type: [Array, null] as PropType<ProjectRoleDto[] | null>,
    },
    roles: {
      default: () => [],
      type: Array as PropType<RoleDto[]>,
    },
  },
  setup() {
    const projectStore = useProjectStore();

    const importUserModal = useModal("importUserModal");

    return { projectStore, importUserModal };
  },
  data() {
    return {
      additionalMembers: [] as ProjectRoleDto[],
      isBusy: false,
      selectedProject: null as string | null,
    };
  },
  computed: {
    additionalProjects(): ProjectDto[] | null {
      if (this.projects && this.project) {
        const currentProject = this.project;
        return this.projects.filter(
          (project) => project.id !== currentProject.id,
        );
      }
      return null;
    },
    projects(): ProjectDto[] | null {
      return this.projectStore.allProjects;
    },
  },
  methods: {
    async getProjectRoles(value: string) {
      this.isBusy = true;
      this.additionalMembers = await this.projectStore.getProjectRoles(value);
      this.additionalMembers = this.additionalMembers.filter(
        (projectRole) =>
          !this.projectRoles?.some(
            (currentProjectRole) =>
              projectRole.user?.id === currentProjectRole.user?.id,
          ),
      );
      this.additionalMembers.forEach((additionalMember) => {
        if (this.memberRole) {
          additionalMember.role = {
            id: this.memberRole.id,
            displayName: this.memberRole.displayName,
          };
        }
      });
      this.isBusy = false;
    },
    importUser() {
      this.selectedProject = null;
      for (const projectRole of this.additionalMembers) {
        if (this.project) {
          projectRole.project = { id: this.project.id };
        }
        this.$emit("addUser", projectRole);
      }
      this.importUserModal.hide();
      this.additionalMembers = [];
    },
    removeSelectedRow(projectRole: ProjectRoleDto) {
      const index = this.additionalMembers.indexOf(projectRole);
      this.additionalMembers.splice(index, 1);
    },
    resetModal() {
      this.selectedProject = null;
      this.additionalMembers = [];
    },
  },
});
</script>
